      double precision function dasum(n,dx,incx)
c
c     takes the sum of the absolute values.
c     jack dongarra, linpack, 3/11/78.
c
      double precision dx(1),dtemp
      integer i,incx,m,mp1,n,nincx
c
      dasum = 0.0d0
      dtemp = 0.0d0
      if(n.le.0)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      nincx = n*incx
      do 10 i = 1,nincx,incx
        dtemp = dtemp + dabs(dx(i))
   10 continue
      dasum = dtemp
      return
c
c        code for increment equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,6)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        dtemp = dtemp + dabs(dx(i))
   30 continue
      if( n .lt. 6 ) go to 60
   40 mp1 = m + 1
      do 50 i = mp1,n,6
        dtemp = dtemp + dabs(dx(i)) + dabs(dx(i + 1)) + dabs(dx(i + 2))
     *  + dabs(dx(i + 3)) + dabs(dx(i + 4)) + dabs(dx(i + 5))
   50 continue
   60 dasum = dtemp
      return
      end

      SUBROUTINE DGEMV ( TRANS, M, N, ALPHA, A, LDA, X, INCX,
     $                   BETA, Y, INCY )
*     .. Scalar Arguments ..
      DOUBLE PRECISION   ALPHA, BETA
      INTEGER            INCX, INCY, LDA, M, N
      CHARACTER*1        TRANS
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), X( * ), Y( * )
*     ..
*
*  Purpose
*  =======
*
*  DGEMV  performs one of the matrix-vector operations
*
*     y := alpha*A*x + beta*y,   or   y := alpha*A'*x + beta*y,
*
*  where alpha and beta are scalars, x and y are vectors and A is an
*  m by n matrix.
*
*  Parameters
*  ==========
*
*  TRANS  - CHARACTER*1.
*           On entry, TRANS specifies the operation to be performed as
*           follows:
*
*              TRANS = 'N' or 'n'   y := alpha*A*x + beta*y.
*
*              TRANS = 'T' or 't'   y := alpha*A'*x + beta*y.
*
*              TRANS = 'C' or 'c'   y := alpha*A'*x + beta*y.
*
*           Unchanged on exit.
*
*  M      - INTEGER.
*           On entry, M specifies the number of rows of the matrix A.
*           M must be at least zero.
*           Unchanged on exit.
*
*  N      - INTEGER.
*           On entry, N specifies the number of columns of the matrix A.
*           N must be at least zero.
*           Unchanged on exit.
*
*  ALPHA  - DOUBLE PRECISION.
*           On entry, ALPHA specifies the scalar alpha.
*           Unchanged on exit.
*
*  A      - DOUBLE PRECISION array of DIMENSION ( LDA, n ).
*           Before entry, the leading m by n part of the array A must
*           contain the matrix of coefficients.
*           Unchanged on exit.
*
*  LDA    - INTEGER.
*           On entry, LDA specifies the first dimension of A as declared
*           in the calling (sub) program. LDA must be at least
*           max( 1, m ).
*           Unchanged on exit.
*
*  X      - DOUBLE PRECISION array of DIMENSION at least
*           ( 1 + ( n - 1 )*abs( INCX ) ) when TRANS = 'N' or 'n'
*           and at least
*           ( 1 + ( m - 1 )*abs( INCX ) ) otherwise.
*           Before entry, the incremented array X must contain the
*           vector x.
*           Unchanged on exit.
*
*  INCX   - INTEGER.
*           On entry, INCX specifies the increment for the elements of
*           X. INCX must not be zero.
*           Unchanged on exit.
*
*  BETA   - DOUBLE PRECISION.
*           On entry, BETA specifies the scalar beta. When BETA is
*           supplied as zero then Y need not be set on input.
*           Unchanged on exit.
*
*  Y      - DOUBLE PRECISION array of DIMENSION at least
*           ( 1 + ( m - 1 )*abs( INCY ) ) when TRANS = 'N' or 'n'
*           and at least
*           ( 1 + ( n - 1 )*abs( INCY ) ) otherwise.
*           Before entry with BETA non-zero, the incremented array Y
*           must contain the vector y. On exit, Y is overwritten by the
*           updated vector y.
*
*  INCY   - INTEGER.
*           On entry, INCY specifies the increment for the elements of
*           Y. INCY must not be zero.
*           Unchanged on exit.
*
*
*  Level 2 Blas routine.
*
*  -- Written on 22-October-1986.
*     Jack Dongarra, Argonne National Lab.
*     Jeremy Du Croz, Nag Central Office.
*     Sven Hammarling, Nag Central Office.
*     Richard Hanson, Sandia National Labs.
*
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE         , ZERO
      PARAMETER        ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     .. Local Scalars ..
      DOUBLE PRECISION   TEMP
      INTEGER            I, INFO, IX, IY, J, JX, JY, KX, KY, LENX, LENY
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF     ( .NOT.LSAME( TRANS, 'N' ).AND.
     $         .NOT.LSAME( TRANS, 'T' ).AND.
     $         .NOT.LSAME( TRANS, 'C' )      )THEN
         INFO = 1
      ELSE IF( M.LT.0 )THEN
         INFO = 2
      ELSE IF( N.LT.0 )THEN
         INFO = 3
      ELSE IF( LDA.LT.MAX( 1, M ) )THEN
         INFO = 6
      ELSE IF( INCX.EQ.0 )THEN
         INFO = 8
      ELSE IF( INCY.EQ.0 )THEN
         INFO = 11
      END IF
      IF( INFO.NE.0 )THEN
         CALL XERBLA( 'DGEMV ', INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( ( M.EQ.0 ).OR.( N.EQ.0 ).OR.
     $    ( ( ALPHA.EQ.ZERO ).AND.( BETA.EQ.ONE ) ) )
     $   RETURN
*
*     Set  LENX  and  LENY, the lengths of the vectors x and y, and set
*     up the start points in  X  and  Y.
*
      IF( LSAME( TRANS, 'N' ) )THEN
         LENX = N
         LENY = M
      ELSE
         LENX = M
         LENY = N
      END IF
      IF( INCX.GT.0 )THEN
         KX = 1
      ELSE
         KX = 1 - ( LENX - 1 )*INCX
      END IF
      IF( INCY.GT.0 )THEN
         KY = 1
      ELSE
         KY = 1 - ( LENY - 1 )*INCY
      END IF
*
*     Start the operations. In this version the elements of A are
*     accessed sequentially with one pass through A.
*
*     First form  y := beta*y.
*
      IF( BETA.NE.ONE )THEN
         IF( INCY.EQ.1 )THEN
            IF( BETA.EQ.ZERO )THEN
               DO 10, I = 1, LENY
                  Y( I ) = ZERO
   10          CONTINUE
            ELSE
               DO 20, I = 1, LENY
                  Y( I ) = BETA*Y( I )
   20          CONTINUE
            END IF
         ELSE
            IY = KY
            IF( BETA.EQ.ZERO )THEN
               DO 30, I = 1, LENY
                  Y( IY ) = ZERO
                  IY      = IY   + INCY
   30          CONTINUE
            ELSE
               DO 40, I = 1, LENY
                  Y( IY ) = BETA*Y( IY )
                  IY      = IY           + INCY
   40          CONTINUE
            END IF
         END IF
      END IF
      IF( ALPHA.EQ.ZERO )
     $   RETURN
      IF( LSAME( TRANS, 'N' ) )THEN
*
*        Form  y := alpha*A*x + y.
*
         JX = KX
         IF( INCY.EQ.1 )THEN
            DO 60, J = 1, N
               IF( X( JX ).NE.ZERO )THEN
                  TEMP = ALPHA*X( JX )
                  DO 50, I = 1, M
                     Y( I ) = Y( I ) + TEMP*A( I, J )
   50             CONTINUE
               END IF
               JX = JX + INCX
   60       CONTINUE
         ELSE
            DO 80, J = 1, N
               IF( X( JX ).NE.ZERO )THEN
                  TEMP = ALPHA*X( JX )
                  IY   = KY
                  DO 70, I = 1, M
                     Y( IY ) = Y( IY ) + TEMP*A( I, J )
                     IY      = IY      + INCY
   70             CONTINUE
               END IF
               JX = JX + INCX
   80       CONTINUE
         END IF
      ELSE
*
*        Form  y := alpha*A'*x + y.
*
         JY = KY
         IF( INCX.EQ.1 )THEN
            DO 100, J = 1, N
               TEMP = ZERO
               DO 90, I = 1, M
                  TEMP = TEMP + A( I, J )*X( I )
   90          CONTINUE
               Y( JY ) = Y( JY ) + ALPHA*TEMP
               JY      = JY      + INCY
  100       CONTINUE
         ELSE
            DO 120, J = 1, N
               TEMP = ZERO
               IX   = KX
               DO 110, I = 1, M
                  TEMP = TEMP + A( I, J )*X( IX )
                  IX   = IX   + INCX
  110          CONTINUE
               Y( JY ) = Y( JY ) + ALPHA*TEMP
               JY      = JY      + INCY
  120       CONTINUE
         END IF
      END IF
*
      RETURN
*
*     End of DGEMV .
*
      END

      SUBROUTINE DGER  ( M, N, ALPHA, X, INCX, Y, INCY, A, LDA )
*     .. Scalar Arguments ..
      DOUBLE PRECISION   ALPHA
      INTEGER            INCX, INCY, LDA, M, N
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), X( * ), Y( * )
*     ..
*
*  Purpose
*  =======
*
*  DGER   performs the rank 1 operation
*
*     A := alpha*x*y' + A,
*
*  where alpha is a scalar, x is an m element vector, y is an n element
*  vector and A is an m by n matrix.
*
*  Parameters
*  ==========
*
*  M      - INTEGER.
*           On entry, M specifies the number of rows of the matrix A.
*           M must be at least zero.
*           Unchanged on exit.
*
*  N      - INTEGER.
*           On entry, N specifies the number of columns of the matrix A.
*           N must be at least zero.
*           Unchanged on exit.
*
*  ALPHA  - DOUBLE PRECISION.
*           On entry, ALPHA specifies the scalar alpha.
*           Unchanged on exit.
*
*  X      - DOUBLE PRECISION array of dimension at least
*           ( 1 + ( m - 1 )*abs( INCX ) ).
*           Before entry, the incremented array X must contain the m
*           element vector x.
*           Unchanged on exit.
*
*  INCX   - INTEGER.
*           On entry, INCX specifies the increment for the elements of
*           X. INCX must not be zero.
*           Unchanged on exit.
*
*  Y      - DOUBLE PRECISION array of dimension at least
*           ( 1 + ( n - 1 )*abs( INCY ) ).
*           Before entry, the incremented array Y must contain the n
*           element vector y.
*           Unchanged on exit.
*
*  INCY   - INTEGER.
*           On entry, INCY specifies the increment for the elements of
*           Y. INCY must not be zero.
*           Unchanged on exit.
*
*  A      - DOUBLE PRECISION array of DIMENSION ( LDA, n ).
*           Before entry, the leading m by n part of the array A must
*           contain the matrix of coefficients. On exit, A is
*           overwritten by the updated matrix.
*
*  LDA    - INTEGER.
*           On entry, LDA specifies the first dimension of A as declared
*           in the calling (sub) program. LDA must be at least
*           max( 1, m ).
*           Unchanged on exit.
*
*
*  Level 2 Blas routine.
*
*  -- Written on 22-October-1986.
*     Jack Dongarra, Argonne National Lab.
*     Jeremy Du Croz, Nag Central Office.
*     Sven Hammarling, Nag Central Office.
*     Richard Hanson, Sandia National Labs.
*
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER        ( ZERO = 0.0D+0 )
*     .. Local Scalars ..
      DOUBLE PRECISION   TEMP
      INTEGER            I, INFO, IX, J, JY, KX
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF     ( M.LT.0 )THEN
         INFO = 1
      ELSE IF( N.LT.0 )THEN
         INFO = 2
      ELSE IF( INCX.EQ.0 )THEN
         INFO = 5
      ELSE IF( INCY.EQ.0 )THEN
         INFO = 7
      ELSE IF( LDA.LT.MAX( 1, M ) )THEN
         INFO = 9
      END IF
      IF( INFO.NE.0 )THEN
         CALL XERBLA( 'DGER  ', INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( ( M.EQ.0 ).OR.( N.EQ.0 ).OR.( ALPHA.EQ.ZERO ) )
     $   RETURN
*
*     Start the operations. In this version the elements of A are
*     accessed sequentially with one pass through A.
*
      IF( INCY.GT.0 )THEN
         JY = 1
      ELSE
         JY = 1 - ( N - 1 )*INCY
      END IF
      IF( INCX.EQ.1 )THEN
         DO 20, J = 1, N
            IF( Y( JY ).NE.ZERO )THEN
               TEMP = ALPHA*Y( JY )
               DO 10, I = 1, M
                  A( I, J ) = A( I, J ) + X( I )*TEMP
   10          CONTINUE
            END IF
            JY = JY + INCY
   20    CONTINUE
      ELSE
         IF( INCX.GT.0 )THEN
            KX = 1
         ELSE
            KX = 1 - ( M - 1 )*INCX
         END IF
         DO 40, J = 1, N
            IF( Y( JY ).NE.ZERO )THEN
               TEMP = ALPHA*Y( JY )
               IX   = KX
               DO 30, I = 1, M
                  A( I, J ) = A( I, J ) + X( IX )*TEMP
                  IX        = IX        + INCX
   30          CONTINUE
            END IF
            JY = JY + INCY
   40    CONTINUE
      END IF
*
      RETURN
*
*     End of DGER  .
*
      END

      subroutine daxpy(n,da,dx,incx,dy,incy)
c
c     constant times a vector plus a vector.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c
      double precision dx(1),dy(1),da
      integer i,incx,incy,ix,iy,m,mp1,n
c
      if(n.le.0)return
      if (da .eq. 0.0d0) return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        dy(iy) = dy(iy) + da*dx(ix)
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,4)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        dy(i) = dy(i) + da*dx(i)
   30 continue
      if( n .lt. 4 ) return
   40 mp1 = m + 1
      do 50 i = mp1,n,4
        dy(i) = dy(i) + da*dx(i)
        dy(i + 1) = dy(i + 1) + da*dx(i + 1)
        dy(i + 2) = dy(i + 2) + da*dx(i + 2)
        dy(i + 3) = dy(i + 3) + da*dx(i + 3)
   50 continue
      return
      end

      subroutine  dcopy(n,dx,incx,dy,incy)
c
c     copies a vector, x, to a vector, y.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c
      double precision dx(1),dy(1)
      integer i,incx,incy,ix,iy,m,mp1,n
c
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        dy(iy) = dx(ix)
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,7)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        dy(i) = dx(i)
   30 continue
      if( n .lt. 7 ) return
   40 mp1 = m + 1
      do 50 i = mp1,n,7
        dy(i) = dx(i)
        dy(i + 1) = dx(i + 1)
        dy(i + 2) = dx(i + 2)
        dy(i + 3) = dx(i + 3)
        dy(i + 4) = dx(i + 4)
        dy(i + 5) = dx(i + 5)
        dy(i + 6) = dx(i + 6)
   50 continue
      return
      end

      double precision function ddot(n,dx,incx,dy,incy)
c
c     forms the dot product of two vectors.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c
      double precision dx(1),dy(1),dtemp
      integer i,incx,incy,ix,iy,m,mp1,n
c
      ddot = 0.0d0
      dtemp = 0.0d0
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        dtemp = dtemp + dx(ix)*dy(iy)
        ix = ix + incx
        iy = iy + incy
   10 continue
      ddot = dtemp
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,5)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        dtemp = dtemp + dx(i)*dy(i)
   30 continue
      if( n .lt. 5 ) go to 60
   40 mp1 = m + 1
      do 50 i = mp1,n,5
        dtemp = dtemp + dx(i)*dy(i) + dx(i + 1)*dy(i + 1) +
     *   dx(i + 2)*dy(i + 2) + dx(i + 3)*dy(i + 3) + dx(i + 4)*dy(i + 4)
   50 continue
   60 ddot = dtemp
      return
      end

      double precision function dnrm2 ( n, dx, incx)
      integer          next
      double precision   dx(1), cutlo, cuthi, hitest, sum, xmax,zero,one
      data   zero, one /0.0d0, 1.0d0/
c
c     euclidean norm of the n-vector stored in dx() with storage
c     increment incx .
c     if    n .le. 0 return with result = 0.
c     if n .ge. 1 then incx must be .ge. 1
c
c           c.l.lawson, 1978 jan 08
c
c     four phase method     using two built-in constants that are
c     hopefully applicable to all machines.
c         cutlo = maximum of  dsqrt(u/eps)  over all known machines.
c         cuthi = minimum of  dsqrt(v)      over all known machines.
c     where
c         eps = smallest no. such that eps + 1. .gt. 1.
c         u   = smallest positive no.   (underflow limit)
c         v   = largest  no.            (overflow  limit)
c
c     brief outline of algorithm..
c
c     phase 1    scans zero components.
c     move to phase 2 when a component is nonzero and .le. cutlo
c     move to phase 3 when a component is .gt. cutlo
c     move to phase 4 when a component is .ge. cuthi/m
c     where m = n for x() real and m = 2*n for complex.
c
c     values for cutlo and cuthi..
c     from the environmental parameters listed in the imsl converter
c     document the limiting values are as follows..
c     cutlo, s.p.   u/eps = 2**(-102) for  honeywell.  close seconds are
c                   univac and dec at 2**(-103)
c                   thus cutlo = 2**(-51) = 4.44089e-16
c     cuthi, s.p.   v = 2**127 for univac, honeywell, and dec.
c                   thus cuthi = 2**(63.5) = 1.30438e19
c     cutlo, d.p.   u/eps = 2**(-67) for honeywell and dec.
c                   thus cutlo = 2**(-33.5) = 8.23181d-11
c     cuthi, d.p.   same as s.p.  cuthi = 1.30438d19
c     data cutlo, cuthi / 8.232d-11,  1.304d19 /
c     data cutlo, cuthi / 4.441e-16,  1.304e19 /
      data cutlo, cuthi / 8.232d-11,  1.304d19 /
c
      if(n .gt. 0) go to 10
         dnrm2  = zero
         go to 300
c
   10 assign 30 to next
      sum = zero
      nn = n * incx
c                                                 begin main loop
      i = 1
   20    go to next,(30, 50, 70, 110)
   30 if( dabs(dx(i)) .gt. cutlo) go to 85
      assign 50 to next
      xmax = zero
c
c                        phase 1.  sum is zero
c
   50 if( dx(i) .eq. zero) go to 200
      if( dabs(dx(i)) .gt. cutlo) go to 85
c
c                                prepare for phase 2.
      assign 70 to next
      go to 105
c
c                                prepare for phase 4.
c
  100 i = j
      assign 110 to next
      sum = (sum / dx(i)) / dx(i)
  105 xmax = dabs(dx(i))
      go to 115
c
c                   phase 2.  sum is small.
c                             scale to avoid destructive underflow.
c
   70 if( dabs(dx(i)) .gt. cutlo ) go to 75
c
c                     common code for phases 2 and 4.
c                     in phase 4 sum is large.  scale to avoid overflow.
c
  110 if( dabs(dx(i)) .le. xmax ) go to 115
         sum = one + sum * (xmax / dx(i))**2
         xmax = dabs(dx(i))
         go to 200
c
  115 sum = sum + (dx(i)/xmax)**2
      go to 200
c
c
c                  prepare for phase 3.
c
   75 sum = (sum * xmax) * xmax
c
c
c     for real or d.p. set hitest = cuthi/n
c     for complex      set hitest = cuthi/(2*n)
c
   85 hitest = cuthi/float( n )
c
c                   phase 3.  sum is mid-range.  no scaling.
c
      do 95 j =i,nn,incx
      if(dabs(dx(j)) .ge. hitest) go to 100
   95    sum = sum + dx(j)**2
      dnrm2 = dsqrt( sum )
      go to 300
c
  200 continue
      i = i + incx
      if ( i .le. nn ) go to 20
c
c              end of main loop.
c
c              compute square root and adjust for scaling.
c
      dnrm2 = xmax * dsqrt(sum)
  300 continue
      return
      end

      subroutine  drot (n,dx,incx,dy,incy,c,s)
c
c     applies a plane rotation.
c     jack dongarra, linpack, 3/11/78.
c
      double precision dx(1),dy(1),dtemp,c,s
      integer i,incx,incy,ix,iy,n
c
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c       code for unequal increments or equal increments not equal
c         to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        dtemp = c*dx(ix) + s*dy(iy)
        dy(iy) = c*dy(iy) - s*dx(ix)
        dx(ix) = dtemp
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
c
c       code for both increments equal to 1
c
   20 do 30 i = 1,n
        dtemp = c*dx(i) + s*dy(i)
        dy(i) = c*dy(i) - s*dx(i)
        dx(i) = dtemp
   30 continue
      return
      end

      subroutine drotg(da,db,c,s)
c
c     construct givens plane rotation.
c     jack dongarra, linpack, 3/11/78.
c                    modified 9/27/86.
c
      double precision da,db,c,s,roe,scale,r,z
c
      roe = db
      if( dabs(da) .gt. dabs(db) ) roe = da
      scale = dabs(da) + dabs(db)
      if( scale .ne. 0.0d0 ) go to 10
         c = 1.0d0
         s = 0.0d0
         r = 0.0d0
         go to 20
   10 r = scale*dsqrt((da/scale)**2 + (db/scale)**2)
      r = dsign(1.0d0,roe)*r
      c = da/r
      s = db/r
   20 z = s
      if( dabs(c) .gt. 0.0d0 .and. dabs(c) .le. s ) z = 1.0d0/c
      da = r
      db = z
      return
      end


      subroutine  dscal(n,da,dx,incx)
c
c     scales a vector by a constant.
c     uses unrolled loops for increment equal to one.
c     jack dongarra, linpack, 3/11/78.
c
      double precision da,dx(1)
      integer i,incx,m,mp1,n,nincx
c
      if(n.le.0)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      nincx = n*incx
      do 10 i = 1,nincx,incx
        dx(i) = da*dx(i)
   10 continue
      return
c
c        code for increment equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,5)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        dx(i) = da*dx(i)
   30 continue
      if( n .lt. 5 ) return
   40 mp1 = m + 1
      do 50 i = mp1,n,5
        dx(i) = da*dx(i)
        dx(i + 1) = da*dx(i + 1)
        dx(i + 2) = da*dx(i + 2)
        dx(i + 3) = da*dx(i + 3)
        dx(i + 4) = da*dx(i + 4)
   50 continue
      return
      end

      integer function idamax(n,dx,incx)
c
c     finds the index of element having max. absolute value.
c     jack dongarra, linpack, 3/11/78.
c
      double precision dx(1),dmax
      integer i,incx,ix,n
c
      idamax = 0
      if( n .lt. 1 ) return
      idamax = 1
      if(n.eq.1)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      ix = 1
      dmax = dabs(dx(1))
      ix = ix + incx
      do 10 i = 2,n
         if(dabs(dx(ix)).le.dmax) go to 5
         idamax = i
         dmax = dabs(dx(ix))
    5    ix = ix + incx
   10 continue
      return
c
c        code for increment equal to 1
c
   20 dmax = dabs(dx(1))
      do 30 i = 2,n
         if(dabs(dx(i)).le.dmax) go to 30
         idamax = i
         dmax = dabs(dx(i))
   30 continue
      return
      end

      SUBROUTINE XERBLA ( SRNAME, INFO )
*     ..    Scalar Arguments ..
      INTEGER            INFO
      CHARACTER*6        SRNAME
*     ..
*
*  Purpose
*  =======
*
*  XERBLA  is an error handler for the Level 2 BLAS routines.
*
*  It is called by the Level 2 BLAS routines if an input parameter is
*  invalid.
*
*  Installers should consider modifying the STOP statement in order to
*  call system-specific exception-handling facilities.
*
*  Parameters
*  ==========
*
*  SRNAME - CHARACTER*6.
*           On entry, SRNAME specifies the name of the routine which
*           called XERBLA.
*
*  INFO   - INTEGER.
*           On entry, INFO specifies the position of the invalid
*           parameter in the parameter-list of the calling routine.
*
*
*  Auxiliary routine for Level 2 Blas.
*
*  Written on 20-July-1986.
*
*     .. Executable Statements ..
*
      WRITE (*,99999) SRNAME, INFO
*
      STOP
*
99999 FORMAT ( ' ** On entry to ', A6, ' parameter number ', I2,
     $         ' had an illegal value' )
*
*     End of XERBLA.
*
      END

      LOGICAL FUNCTION LSAME ( CA, CB )
*     .. Scalar Arguments ..
      CHARACTER*1            CA, CB
*     ..
*
*  Purpose
*  =======
*
*  LSAME  tests if CA is the same letter as CB regardless of case.
*  CB is assumed to be an upper case letter. LSAME returns .TRUE. if
*  CA is either the same as CB or the equivalent lower case letter.
*
*  N.B. This version of the routine is only correct for ASCII code.
*       Installers must modify the routine for other character-codes.
*
*       For EBCDIC systems the constant IOFF must be changed to -64.
*       For CDC systems using 6-12 bit representations, the system-
*       specific code in comments must be activated.
*
*  Parameters
*  ==========
*
*  CA     - CHARACTER*1
*  CB     - CHARACTER*1
*           On entry, CA and CB specify characters to be compared.
*           Unchanged on exit.
*
*
*  Auxiliary routine for Level 2 Blas.
*
*  -- Written on 20-July-1986
*     Richard Hanson, Sandia National Labs.
*     Jeremy Du Croz, Nag Central Office.
*
*     .. Parameters ..
      INTEGER                IOFF
      PARAMETER            ( IOFF=32 )
*     .. Intrinsic Functions ..
      INTRINSIC              ICHAR
*     .. Executable Statements ..
*
*     Test if the characters are equal
*
      LSAME = CA .EQ. CB
*
*     Now test for equivalence
*
      IF ( .NOT.LSAME ) THEN
         LSAME = ICHAR(CA) - IOFF .EQ. ICHAR(CB)
      END IF
*
      RETURN
*
*  The following comments contain code for CDC systems using 6-12 bit
*  representations.
*
*     .. Parameters ..
*     INTEGER                ICIRFX
*     PARAMETER            ( ICIRFX=62 )
*     .. Scalar Arguments ..
*     CHARACTER*1            CB
*     .. Array Arguments ..
*     CHARACTER*1            CA(*)
*     .. Local Scalars ..
*     INTEGER                IVAL
*     .. Intrinsic Functions ..
*     INTRINSIC              ICHAR, CHAR
*     .. Executable Statements ..
*
*     See if the first character in string CA equals string CB.
*
*     LSAME = CA(1) .EQ. CB .AND. CA(1) .NE. CHAR(ICIRFX)
*
*     IF (LSAME) RETURN
*
*     The characters are not identical. Now check them for equivalence.
*     Look for the 'escape' character, circumflex, followed by the
*     letter.
*
*     IVAL = ICHAR(CA(2))
*     IF (IVAL.GE.ICHAR('A') .AND. IVAL.LE.ICHAR('Z')) THEN
*        LSAME = CA(1) .EQ. CHAR(ICIRFX) .AND. CA(2) .EQ. CB
*     END IF
*
*     RETURN
*
*     End of LSAME.
*
      END
      subroutine  dswap (n,dx,incx,dy,incy)
c
c     interchanges two vectors.
c     uses unrolled loops for increments equal one.
c     jack dongarra, linpack, 3/11/78.
c
      double precision dx(1),dy(1),dtemp
      integer i,incx,incy,ix,iy,m,mp1,n
c
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c       code for unequal increments or equal increments not equal
c         to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        dtemp = dx(ix)
        dx(ix) = dy(iy)
        dy(iy) = dtemp
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
c
c       code for both increments equal to 1
c
c
c       clean-up loop
c
   20 m = mod(n,3)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        dtemp = dx(i)
        dx(i) = dy(i)
        dy(i) = dtemp
   30 continue
      if( n .lt. 3 ) return
   40 mp1 = m + 1
      do 50 i = mp1,n,3
        dtemp = dx(i)
        dx(i) = dy(i)
        dy(i) = dtemp
        dtemp = dx(i + 1)
        dx(i + 1) = dy(i + 1)
        dy(i + 1) = dtemp
        dtemp = dx(i + 2)
        dx(i + 2) = dy(i + 2)
        dy(i + 2) = dtemp
   50 continue
      return
      end

c -------------------------------------------------------------------------
c     Single-layer net, "quadratic" squasher
c         Inputs: X       (n-d) x d data matrix    (d lags, n data points)
c                 gama    K x d matrix             (K=# of hidden units)
c                 beta    K+1 x 1 column vector
c                 mu      K x 1 row vector
c         Output: gk=   beta * G(X*gama' .+ mu')
c -------------------------------------------------------------------------
        subroutine net(xout,xin,beta,amu,gama,nx,jd,k)
        implicit real*8(a-h,o-z)
        parameter(kmax=8,jdmax=10,nxmax=525,hf=0.5,one=1.d0,two=2.d0)
        dimension xout(nxmax),xin(nxmax,jdmax),uin(nxmax,kmax)
        dimension gama(kmax,jdmax),beta(kmax+1),amu(kmax)
	do 10 it=1,nx
		xout(it)=beta(1)
10	continue
	do 50 jun=1,k
		u0=amu(jun)
		do 20 it=1,nx
			uin(it,jun)=u0
20 		continue

		do 40 lag=1,jd
			gjunlag=gama(jun,lag)
			do 30 it=1,nx
			   uin(it,jun)=uin(it,jun)+gjunlag*xin(it,lag)
30			continue
40		continue
50	continue
	do 100 jun=1,k
		do 90 it=1,nx
			uinij=uin(it,jun)
			auin=abs(uinij)
			xout(it)=xout(it)+beta(1+jun)*uinij
     *   		*(one+hf*auin)/(two+auin+hf*auin**2)
90		continue
100	continue
        return
        end
C=============================================================
        subroutine objfun(mode,npar,theta,f,g,nstate)
c
c           npar  = # of variables   (input integer)
c           theta = evaluation point (input vector of length nvar)
c           f     = function value   (output scalar)
c           g     = gradient value   (output vector of length nvar)
c           mode  ==  0 then compute f, leave g unchanged
c                 ==  1 then compute g, leave f unchanged
c                 ==  2 then compute both f and g
c          nstate = not used; included for compatibility with NPSOL

        implicit real*8(a-h,o-z)
        parameter(kmax=8,jdmax=10,nxmax=525)
        parameter(npmax=1+kmax*(jdmax+2))
        parameter(zero=0.d0,one=1.d0,hf=0.5d0,two=2.d0)
        common /size/ k,jd,nx,m,jforce
        common /xdata/ xt,xlag
        dimension gama(kmax,jdmax)
        dimension xt(nxmax),xout(nxmax),xlag(nxmax,jdmax)
        dimension theta(npar),g(npar)

        m0=k+1
        j0=2*k+1
	jdf=jd+2*jforce

c ------  extract gamma matrix from theta vector
        do 30 iunit=1,k
            loc0=j0+(iunit-1)*jdf
            do 20 lag=1,jdf
                gama(iunit,lag)=theta(loc0+lag)
20          continue
30      continue

c ---------- compute predicted values (xout)
        call net(xout,xlag,theta(1),theta(m0+1),gama,nx,jdf,k)

c----------- compute objective function f (mean square prediction error)
        sse=zero
        if (mode.eq.0) then
            do 50 i=1,m
                sse=sse+(xout(i)-xt(i))**2
50          continue
            f=sqrt(sse/dfloat(m))
        else

c ---------- compute objective function & its gradient vector
	    do 55 j=1,npar
		g(j)=zero
55	    continue
            do 90 i=1,m
	      fi=xout(i)-xt(i)
              sse=sse+fi**2
	      g(1)=g(1)+fi
              do 80 j=1,k
                uin=theta(m0+j)
                do 60 lag=1,jdf
                    uin=uin+gama(j,lag)*xlag(i,lag)
60              continue
                auin=abs(uin)
                dij=(two+auin +hf*(auin**2))
	        g(j+1)=g(j+1)+fi*uin*(one + hf*auin)/dij
                gpij=two*(one+auin)/(dij**2)
		g(m0+j)=g(m0+j)+fi*theta(1+j)*gpij
                loc0=j0+(j-1)*jdf
                do 70 lag=1,jdf
                   g(loc0+lag)=g(loc0+lag)
     &                          +fi*theta(1+j)*xlag(i,lag)*gpij
70              continue
80            continue
90         continue
       
           fac=one/sqrt(sse*dfloat(m))
           do 120 j=1,npar
               g(j)=fac*g(j)
120        continue
           if (mode.eq.2) f=sqrt(sse/dfloat(m))
        endif
        return
        end

      SUBROUTINE DQRDC(X,LDX,N,P,QRAUX,JPVT,WORK,JOB)
      INTEGER LDX,N,P,JOB
      INTEGER JPVT(1)
      DOUBLE PRECISION X(LDX,1),QRAUX(1),WORK(1)
C
C     DQRDC USES HOUSEHOLDER TRANSFORMATIONS TO COMPUTE THE QR
C     FACTORIZATION OF AN N BY P MATRIX X.  COLUMN PIVOTING
C     BASED ON THE 2-NORMS OF THE REDUCED COLUMNS MAY BE
C     PERFORMED AT THE USERS OPTION.
C
C     ON ENTRY
C
C        X       DOUBLE PRECISION(LDX,P), WHERE LDX .GE. N.
C                X CONTAINS THE MATRIX WHOSE DECOMPOSITION IS TO BE
C                COMPUTED.
C
C        LDX     INTEGER.
C                LDX IS THE LEADING DIMENSION OF THE ARRAY X.
C
C        N       INTEGER.
C                N IS THE NUMBER OF ROWS OF THE MATRIX X.
C
C        P       INTEGER.
C                P IS THE NUMBER OF COLUMNS OF THE MATRIX X.
C
C        JPVT    INTEGER(P).
C                JPVT CONTAINS INTEGERS THAT CONTROL THE SELECTION
C                OF THE PIVOT COLUMNS.  THE K-TH COLUMN X(K) OF X
C                IS PLACED IN ONE OF THREE CLASSES ACCORDING TO THE
C                VALUE OF JPVT(K).
C
C                   IF JPVT(K) .GT. 0, THEN X(K) IS AN INITIAL
C                                      COLUMN.
C
C                   IF JPVT(K) .EQ. 0, THEN X(K) IS A FREE COLUMN.
C
C                   IF JPVT(K) .LT. 0, THEN X(K) IS A FINAL COLUMN.
C
C                BEFORE THE DECOMPOSITION IS COMPUTED, INITIAL COLUMNS
C                ARE MOVED TO THE BEGINNING OF THE ARRAY X AND FINAL
C                COLUMNS TO THE END.  BOTH INITIAL AND FINAL COLUMNS
C                ARE FROZEN IN PLACE DURING THE COMPUTATION AND ONLY
C                FREE COLUMNS ARE MOVED.  AT THE K-TH STAGE OF THE
C                REDUCTION, IF X(K) IS OCCUPIED BY A FREE COLUMN
C                IT IS INTERCHANGED WITH THE FREE COLUMN OF LARGEST
C                REDUCED NORM.  JPVT IS NOT REFERENCED IF
C                JOB .EQ. 0.
C
C        WORK    DOUBLE PRECISION(P).
C                WORK IS A WORK ARRAY.  WORK IS NOT REFERENCED IF
C                JOB .EQ. 0.
C
C        JOB     INTEGER.
C                JOB IS AN INTEGER THAT INITIATES COLUMN PIVOTING.
C                IF JOB .EQ. 0, NO PIVOTING IS DONE.
C                IF JOB .NE. 0, PIVOTING IS DONE.
C
C     ON RETURN
C
C        X       X CONTAINS IN ITS UPPER TRIANGLE THE UPPER
C                TRIANGULAR MATRIX R OF THE QR FACTORIZATION.
C                BELOW ITS DIAGONAL X CONTAINS INFORMATION FROM
C                WHICH THE ORTHOGONAL PART OF THE DECOMPOSITION
C                CAN BE RECOVERED.  NOTE THAT IF PIVOTING HAS
C                BEEN REQUESTED, THE DECOMPOSITION IS NOT THAT
C                OF THE ORIGINAL MATRIX X BUT THAT OF X
C                WITH ITS COLUMNS PERMUTED AS DESCRIBED BY JPVT.
C
C        QRAUX   DOUBLE PRECISION(P).
C                QRAUX CONTAINS FURTHER INFORMATION REQUIRED TO RECOVER
C                THE ORTHOGONAL PART OF THE DECOMPOSITION.
C
C        JPVT    JPVT(K) CONTAINS THE INDEX OF THE COLUMN OF THE
C                ORIGINAL MATRIX THAT HAS BEEN INTERCHANGED INTO
C                THE K-TH COLUMN, IF PIVOTING WAS REQUESTED.
C
C     LINPACK. THIS VERSION DATED 08/14/78 .
C     G.W. STEWART, UNIVERSITY OF MARYLAND, ARGONNE NATIONAL LAB.
C
C     DQRDC USES THE FOLLOWING FUNCTIONS AND SUBPROGRAMS.
C
C     BLAS DAXPY,DDOT,DSCAL,DSWAP,DNRM2
C     FORTRAN DABS,DMAX1,MIN0,DSQRT
C
C     INTERNAL VARIABLES
C
      INTEGER J,JP,L,LP1,LUP,MAXJ,PL,PU
      DOUBLE PRECISION MAXNRM,DNRM2,TT
      DOUBLE PRECISION DDOT,NRMXL,T
      LOGICAL NEGJ,SWAPJ
C
C
      PL = 1
      PU = 0
      IF (JOB .EQ. 0) GO TO 60
C
C        PIVOTING HAS BEEN REQUESTED.  REARRANGE THE COLUMNS
C        ACCORDING TO JPVT.
C
         DO 20 J = 1, P
            SWAPJ = JPVT(J) .GT. 0
            NEGJ = JPVT(J) .LT. 0
            JPVT(J) = J
            IF (NEGJ) JPVT(J) = -J
            IF (.NOT.SWAPJ) GO TO 10
               IF (J .NE. PL) CALL DSWAP(N,X(1,PL),1,X(1,J),1)
               JPVT(J) = JPVT(PL)
               JPVT(PL) = J
               PL = PL + 1
   10       CONTINUE
   20    CONTINUE
         PU = P
         DO 50 JJ = 1, P
            J = P - JJ + 1
            IF (JPVT(J) .GE. 0) GO TO 40
               JPVT(J) = -JPVT(J)
               IF (J .EQ. PU) GO TO 30
                  CALL DSWAP(N,X(1,PU),1,X(1,J),1)
                  JP = JPVT(PU)
                  JPVT(PU) = JPVT(J)
                  JPVT(J) = JP
   30          CONTINUE
               PU = PU - 1
   40       CONTINUE
   50    CONTINUE
   60 CONTINUE
C
C     COMPUTE THE NORMS OF THE FREE COLUMNS.
C
      IF (PU .LT. PL) GO TO 80
      DO 70 J = PL, PU
         QRAUX(J) = DNRM2(N,X(1,J),1)
         WORK(J) = QRAUX(J)
   70 CONTINUE
   80 CONTINUE
C
C     PERFORM THE HOUSEHOLDER REDUCTION OF X.
C
      LUP = MIN0(N,P)
      DO 200 L = 1, LUP
         IF (L .LT. PL .OR. L .GE. PU) GO TO 120
C
C           LOCATE THE COLUMN OF LARGEST NORM AND BRING IT
C           INTO THE PIVOT POSITION.
C
            MAXNRM = 0.0D0
            MAXJ = L
            DO 100 J = L, PU
               IF (QRAUX(J) .LE. MAXNRM) GO TO 90
                  MAXNRM = QRAUX(J)
                  MAXJ = J
   90          CONTINUE
  100       CONTINUE
            IF (MAXJ .EQ. L) GO TO 110
               CALL DSWAP(N,X(1,L),1,X(1,MAXJ),1)
               QRAUX(MAXJ) = QRAUX(L)
               WORK(MAXJ) = WORK(L)
               JP = JPVT(MAXJ)
               JPVT(MAXJ) = JPVT(L)
               JPVT(L) = JP
  110       CONTINUE
  120    CONTINUE
         QRAUX(L) = 0.0D0
         IF (L .EQ. N) GO TO 190
C
C           COMPUTE THE HOUSEHOLDER TRANSFORMATION FOR COLUMN L.
C
            NRMXL = DNRM2(N-L+1,X(L,L),1)
            IF (NRMXL .EQ. 0.0D0) GO TO 180
               IF (X(L,L) .NE. 0.0D0) NRMXL = DSIGN(NRMXL,X(L,L))
               CALL DSCAL(N-L+1,1.0D0/NRMXL,X(L,L),1)
               X(L,L) = 1.0D0 + X(L,L)
C
C              APPLY THE TRANSFORMATION TO THE REMAINING COLUMNS,
C              UPDATING THE NORMS.
C
               LP1 = L + 1
               IF (P .LT. LP1) GO TO 170
               DO 160 J = LP1, P
                  T = -DDOT(N-L+1,X(L,L),1,X(L,J),1)/X(L,L)
                  CALL DAXPY(N-L+1,T,X(L,L),1,X(L,J),1)
                  IF (J .LT. PL .OR. J .GT. PU) GO TO 150
                  IF (QRAUX(J) .EQ. 0.0D0) GO TO 150
                     TT = 1.0D0 - (DABS(X(L,J))/QRAUX(J))**2
                     TT = DMAX1(TT,0.0D0)
                     T = TT
                     TT = 1.0D0 + 0.05D0*TT*(QRAUX(J)/WORK(J))**2
                     IF (TT .EQ. 1.0D0) GO TO 130
                        QRAUX(J) = QRAUX(J)*DSQRT(T)
                     GO TO 140
  130                CONTINUE
                        QRAUX(J) = DNRM2(N-L,X(L+1,J),1)
                        WORK(J) = QRAUX(J)
  140                CONTINUE
  150             CONTINUE
  160          CONTINUE
  170          CONTINUE
C
C              SAVE THE TRANSFORMATION.
C
               QRAUX(L) = X(L,L)
               X(L,L) = -NRMXL
  180       CONTINUE
  190    CONTINUE
  200 CONTINUE
      RETURN
      END

      SUBROUTINE DSVDC(X,LDX,N,P,S,E,U,LDU,V,LDV,WORK,JOB,INFO)
      INTEGER LDX,N,P,LDU,LDV,JOB,INFO
      DOUBLE PRECISION X(LDX,1),S(1),E(1),U(LDU,1),V(LDV,1),WORK(1)
C
C
C     DSVDC IS A SUBROUTINE TO REDUCE A DOUBLE PRECISION NXP MATRIX X
C     BY ORTHOGONAL TRANSFORMATIONS U AND V TO DIAGONAL FORM.  THE
C     DIAGONAL ELEMENTS S(I) ARE THE SINGULAR VALUES OF X.  THE
C     COLUMNS OF U ARE THE CORRESPONDING LEFT SINGULAR VECTORS,
C     AND THE COLUMNS OF V THE RIGHT SINGULAR VECTORS.
C
C     ON ENTRY
C
C         X         DOUBLE PRECISION(LDX,P), WHERE LDX.GE.N.
C                   X CONTAINS THE MATRIX WHOSE SINGULAR VALUE
C                   DECOMPOSITION IS TO BE COMPUTED.  X IS
C                   DESTROYED BY DSVDC.
C
C         LDX       INTEGER.
C                   LDX IS THE LEADING DIMENSION OF THE ARRAY X.
C
C         N         INTEGER.
C                   N IS THE NUMBER OF COLUMNS OF THE MATRIX X.
C
C         P         INTEGER.
C                   P IS THE NUMBER OF ROWS OF THE MATRIX X.
C
C         LDU       INTEGER.
C                   LDU IS THE LEADING DIMENSION OF THE ARRAY U.
C                   (SEE BELOW).
C
C         LDV       INTEGER.
C                   LDV IS THE LEADING DIMENSION OF THE ARRAY V.
C                   (SEE BELOW).
C
C         WORK      DOUBLE PRECISION(N).
C                   WORK IS A SCRATCH ARRAY.
C
C         JOB       INTEGER.
C                   JOB CONTROLS THE COMPUTATION OF THE SINGULAR
C                   VECTORS.  IT HAS THE DECIMAL EXPANSION AB
C                   WITH THE FOLLOWING MEANING
C
C                        A.EQ.0    DO NOT COMPUTE THE LEFT SINGULAR
C                                  VECTORS.
C                        A.EQ.1    RETURN THE N LEFT SINGULAR VECTORS
C                                  IN U.
C                        A.GE.2    RETURN THE FIRST MIN(N,P) SINGULAR
C                                  VECTORS IN U.
C                        B.EQ.0    DO NOT COMPUTE THE RIGHT SINGULAR
C                                  VECTORS.
C                        B.EQ.1    RETURN THE RIGHT SINGULAR VECTORS
C                                  IN V.
C
C     ON RETURN
C
C         S         DOUBLE PRECISION(MM), WHERE MM=MIN(N+1,P).
C                   THE FIRST MIN(N,P) ENTRIES OF S CONTAIN THE
C                   SINGULAR VALUES OF X ARRANGED IN DESCENDING
C                   ORDER OF MAGNITUDE.
C
C         E         DOUBLE PRECISION(P).
C                   E ORDINARILY CONTAINS ZEROS.  HOWEVER SEE THE
C                   DISCUSSION OF INFO FOR EXCEPTIONS.
C
C         U         DOUBLE PRECISION(LDU,K), WHERE LDU.GE.N.  IF
C                                   JOBA.EQ.1 THEN K.EQ.N, IF JOBA.GE.2
C                                   THEN K.EQ.MIN(N,P).
C                   U CONTAINS THE MATRIX OF RIGHT SINGULAR VECTORS.
C                   U IS NOT REFERENCED IF JOBA.EQ.0.  IF N.LE.P
C                   OR IF JOBA.EQ.2, THEN U MAY BE IDENTIFIED WITH X
C                   IN THE SUBROUTINE CALL.
C
C         V         DOUBLE PRECISION(LDV,P), WHERE LDV.GE.P.
C                   V CONTAINS THE MATRIX OF RIGHT SINGULAR VECTORS.
C                   V IS NOT REFERENCED IF JOB.EQ.0.  IF P.LE.N,
C                   THEN V MAY BE IDENTIFIED WITH X IN THE
C                   SUBROUTINE CALL.
C
C         INFO      INTEGER.
C                   THE SINGULAR VALUES (AND THEIR CORRESPONDING
C                   SINGULAR VECTORS) S(INFO+1),S(INFO+2),...,S(M)
C                   ARE CORRECT (HERE M=MIN(N,P)).  THUS IF
C                   INFO.EQ.0, ALL THE SINGULAR VALUES AND THEIR
C                   VECTORS ARE CORRECT.  IN ANY EVENT, THE MATRIX
C                   B = TRANS(U)*X*V IS THE BIDIAGONAL MATRIX
C                   WITH THE ELEMENTS OF S ON ITS DIAGONAL AND THE
C                   ELEMENTS OF E ON ITS SUPER-DIAGONAL (TRANS(U)
C                   IS THE TRANSPOSE OF U).  THUS THE SINGULAR
C                   VALUES OF X AND B ARE THE SAME.
C
C     LINPACK. THIS VERSION DATED 03/19/79 .
C     G.W. STEWART, UNIVERSITY OF MARYLAND, ARGONNE NATIONAL LAB.
C
C     DSVDC USES THE FOLLOWING FUNCTIONS AND SUBPROGRAMS.
C
C     EXTERNAL DROT
C     BLAS DAXPY,DDOT,DSCAL,DSWAP,DNRM2,DROTG
C     FORTRAN DABS,DMAX1,MAX0,MIN0,MOD,DSQRT
C
C     INTERNAL VARIABLES
C
      INTEGER I,ITER,J,JOBU,K,KASE,KK,L,LL,LLS,LM1,LP1,LS,LU,M,MAXIT,
     *        MM,MM1,MP1,NCT,NCTP1,NCU,NRT,NRTP1
      DOUBLE PRECISION DDOT,T
      DOUBLE PRECISION B,C,CS,EL,EMM1,F,G,DNRM2,SCALE,SHIFT,SL,SM,SN,
     *                 SMM1,T1,TEST,ZTEST
      LOGICAL WANTU,WANTV
C
C
C     SET THE MAXIMUM NUMBER OF ITERATIONS.
C
      MAXIT = 30
C
C     DETERMINE WHAT IS TO BE COMPUTED.
C
      WANTU = .FALSE.
      WANTV = .FALSE.
      JOBU = MOD(JOB,100)/10
      NCU = N
      IF (JOBU .GT. 1) NCU = MIN0(N,P)
      IF (JOBU .NE. 0) WANTU = .TRUE.
      IF (MOD(JOB,10) .NE. 0) WANTV = .TRUE.
C
C     REDUCE X TO BIDIAGONAL FORM, STORING THE DIAGONAL ELEMENTS
C     IN S AND THE SUPER-DIAGONAL ELEMENTS IN E.
C
      INFO = 0
      NCT = MIN0(N-1,P)
      NRT = MAX0(0,MIN0(P-2,N))
      LU = MAX0(NCT,NRT)
      IF (LU .LT. 1) GO TO 170
      DO 160 L = 1, LU
         LP1 = L + 1
         IF (L .GT. NCT) GO TO 20
C
C           COMPUTE THE TRANSFORMATION FOR THE L-TH COLUMN AND
C           PLACE THE L-TH DIAGONAL IN S(L).
C
            S(L) = DNRM2(N-L+1,X(L,L),1)
            IF (S(L) .EQ. 0.0D0) GO TO 10
               IF (X(L,L) .NE. 0.0D0) S(L) = DSIGN(S(L),X(L,L))
               CALL DSCAL(N-L+1,1.0D0/S(L),X(L,L),1)
               X(L,L) = 1.0D0 + X(L,L)
   10       CONTINUE
            S(L) = -S(L)
   20    CONTINUE
         IF (P .LT. LP1) GO TO 50
         DO 40 J = LP1, P
            IF (L .GT. NCT) GO TO 30
            IF (S(L) .EQ. 0.0D0) GO TO 30
C
C              APPLY THE TRANSFORMATION.
C
               T = -DDOT(N-L+1,X(L,L),1,X(L,J),1)/X(L,L)
               CALL DAXPY(N-L+1,T,X(L,L),1,X(L,J),1)
   30       CONTINUE
C
C           PLACE THE L-TH ROW OF X INTO  E FOR THE
C           SUBSEQUENT CALCULATION OF THE ROW TRANSFORMATION.
C
            E(J) = X(L,J)
   40    CONTINUE
   50    CONTINUE
         IF (.NOT.WANTU .OR. L .GT. NCT) GO TO 70
C
C           PLACE THE TRANSFORMATION IN U FOR SUBSEQUENT BACK
C           MULTIPLICATION.
C
            DO 60 I = L, N
               U(I,L) = X(I,L)
   60       CONTINUE
   70    CONTINUE
         IF (L .GT. NRT) GO TO 150
C
C           COMPUTE THE L-TH ROW TRANSFORMATION AND PLACE THE
C           L-TH SUPER-DIAGONAL IN E(L).
C
            E(L) = DNRM2(P-L,E(LP1),1)
            IF (E(L) .EQ. 0.0D0) GO TO 80
               IF (E(LP1) .NE. 0.0D0) E(L) = DSIGN(E(L),E(LP1))
               CALL DSCAL(P-L,1.0D0/E(L),E(LP1),1)
               E(LP1) = 1.0D0 + E(LP1)
   80       CONTINUE
            E(L) = -E(L)
            IF (LP1 .GT. N .OR. E(L) .EQ. 0.0D0) GO TO 120
C
C              APPLY THE TRANSFORMATION.
C
               DO 90 I = LP1, N
                  WORK(I) = 0.0D0
   90          CONTINUE
               DO 100 J = LP1, P
                  CALL DAXPY(N-L,E(J),X(LP1,J),1,WORK(LP1),1)
  100          CONTINUE
               DO 110 J = LP1, P
                  CALL DAXPY(N-L,-E(J)/E(LP1),WORK(LP1),1,X(LP1,J),1)
  110          CONTINUE
  120       CONTINUE
            IF (.NOT.WANTV) GO TO 140
C
C              PLACE THE TRANSFORMATION IN V FOR SUBSEQUENT
C              BACK MULTIPLICATION.
C
               DO 130 I = LP1, P
                  V(I,L) = E(I)
  130          CONTINUE
  140       CONTINUE
  150    CONTINUE
  160 CONTINUE
  170 CONTINUE
C
C     SET UP THE FINAL BIDIAGONAL MATRIX OR ORDER M.
C
      M = MIN0(P,N+1)
      NCTP1 = NCT + 1
      NRTP1 = NRT + 1
      IF (NCT .LT. P) S(NCTP1) = X(NCTP1,NCTP1)
      IF (N .LT. M) S(M) = 0.0D0
      IF (NRTP1 .LT. M) E(NRTP1) = X(NRTP1,M)
      E(M) = 0.0D0
C
C     IF REQUIRED, GENERATE U.
C
      IF (.NOT.WANTU) GO TO 300
         IF (NCU .LT. NCTP1) GO TO 200
         DO 190 J = NCTP1, NCU
            DO 180 I = 1, N
               U(I,J) = 0.0D0
  180       CONTINUE
            U(J,J) = 1.0D0
  190    CONTINUE
  200    CONTINUE
         IF (NCT .LT. 1) GO TO 290
         DO 280 LL = 1, NCT
            L = NCT - LL + 1
            IF (S(L) .EQ. 0.0D0) GO TO 250
               LP1 = L + 1
               IF (NCU .LT. LP1) GO TO 220
               DO 210 J = LP1, NCU
                  T = -DDOT(N-L+1,U(L,L),1,U(L,J),1)/U(L,L)
                  CALL DAXPY(N-L+1,T,U(L,L),1,U(L,J),1)
  210          CONTINUE
  220          CONTINUE
               CALL DSCAL(N-L+1,-1.0D0,U(L,L),1)
               U(L,L) = 1.0D0 + U(L,L)
               LM1 = L - 1
               IF (LM1 .LT. 1) GO TO 240
               DO 230 I = 1, LM1
                  U(I,L) = 0.0D0
  230          CONTINUE
  240          CONTINUE
            GO TO 270
  250       CONTINUE
               DO 260 I = 1, N
                  U(I,L) = 0.0D0
  260          CONTINUE
               U(L,L) = 1.0D0
  270       CONTINUE
  280    CONTINUE
  290    CONTINUE
  300 CONTINUE
C
C     IF IT IS REQUIRED, GENERATE V.
C
      IF (.NOT.WANTV) GO TO 350
         DO 340 LL = 1, P
            L = P - LL + 1
            LP1 = L + 1
            IF (L .GT. NRT) GO TO 320
            IF (E(L) .EQ. 0.0D0) GO TO 320
               DO 310 J = LP1, P
                  T = -DDOT(P-L,V(LP1,L),1,V(LP1,J),1)/V(LP1,L)
                  CALL DAXPY(P-L,T,V(LP1,L),1,V(LP1,J),1)
  310          CONTINUE
  320       CONTINUE
            DO 330 I = 1, P
               V(I,L) = 0.0D0
  330       CONTINUE
            V(L,L) = 1.0D0
  340    CONTINUE
  350 CONTINUE
C
C     MAIN ITERATION LOOP FOR THE SINGULAR VALUES.
C
      MM = M
      ITER = 0
  360 CONTINUE
C
C        QUIT IF ALL THE SINGULAR VALUES HAVE BEEN FOUND.
C
C     ...EXIT
         IF (M .EQ. 0) GO TO 620
C
C        IF TOO MANY ITERATIONS HAVE BEEN PERFORMED, SET
C        FLAG AND RETURN.
C
         IF (ITER .LT. MAXIT) GO TO 370
            INFO = M
C     ......EXIT
            GO TO 620
  370    CONTINUE
C
C        THIS SECTION OF THE PROGRAM INSPECTS FOR
C        NEGLIGIBLE ELEMENTS IN THE S AND E ARRAYS.  ON
C        COMPLETION THE VARIABLES KASE AND L ARE SET AS FOLLOWS.
C
C           KASE = 1     IF S(M) AND E(L-1) ARE NEGLIGIBLE AND L.LT.M
C           KASE = 2     IF S(L) IS NEGLIGIBLE AND L.LT.M
C           KASE = 3     IF E(L-1) IS NEGLIGIBLE, L.LT.M, AND
C                        S(L), ..., S(M) ARE NOT NEGLIGIBLE (QR STEP).
C           KASE = 4     IF E(M-1) IS NEGLIGIBLE (CONVERGENCE).
C
         DO 390 LL = 1, M
            L = M - LL
C        ...EXIT
            IF (L .EQ. 0) GO TO 400
            TEST = DABS(S(L)) + DABS(S(L+1))
            ZTEST = TEST + DABS(E(L))
            IF (ZTEST .NE. TEST) GO TO 380
               E(L) = 0.0D0
C        ......EXIT
               GO TO 400
  380       CONTINUE
  390    CONTINUE
  400    CONTINUE
         IF (L .NE. M - 1) GO TO 410
            KASE = 4
         GO TO 480
  410    CONTINUE
            LP1 = L + 1
            MP1 = M + 1
            DO 430 LLS = LP1, MP1
               LS = M - LLS + LP1
C           ...EXIT
               IF (LS .EQ. L) GO TO 440
               TEST = 0.0D0
               IF (LS .NE. M) TEST = TEST + DABS(E(LS))
               IF (LS .NE. L + 1) TEST = TEST + DABS(E(LS-1))
               ZTEST = TEST + DABS(S(LS))
               IF (ZTEST .NE. TEST) GO TO 420
                  S(LS) = 0.0D0
C           ......EXIT
                  GO TO 440
  420          CONTINUE
  430       CONTINUE
  440       CONTINUE
            IF (LS .NE. L) GO TO 450
               KASE = 3
            GO TO 470
  450       CONTINUE
            IF (LS .NE. M) GO TO 460
               KASE = 1
            GO TO 470
  460       CONTINUE
               KASE = 2
               L = LS
  470       CONTINUE
  480    CONTINUE
         L = L + 1
C
C        PERFORM THE TASK INDICATED BY KASE.
C
         GO TO (490,520,540,570), KASE
C
C        DEFLATE NEGLIGIBLE S(M).
C
  490    CONTINUE
            MM1 = M - 1
            F = E(M-1)
            E(M-1) = 0.0D0
            DO 510 KK = L, MM1
               K = MM1 - KK + L
               T1 = S(K)
               CALL DROTG(T1,F,CS,SN)
               S(K) = T1
               IF (K .EQ. L) GO TO 500
                  F = -SN*E(K-1)
                  E(K-1) = CS*E(K-1)
  500          CONTINUE
               IF (WANTV) CALL DROT(P,V(1,K),1,V(1,M),1,CS,SN)
  510       CONTINUE
         GO TO 610
C
C        SPLIT AT NEGLIGIBLE S(L).
C
  520    CONTINUE
            F = E(L-1)
            E(L-1) = 0.0D0
            DO 530 K = L, M
               T1 = S(K)
               CALL DROTG(T1,F,CS,SN)
               S(K) = T1
               F = -SN*E(K)
               E(K) = CS*E(K)
               IF (WANTU) CALL DROT(N,U(1,K),1,U(1,L-1),1,CS,SN)
  530       CONTINUE
         GO TO 610
C
C        PERFORM ONE QR STEP.
C
  540    CONTINUE
C
C           CALCULATE THE SHIFT.
C
            SCALE = DMAX1(DABS(S(M)),DABS(S(M-1)),DABS(E(M-1)),
     *                    DABS(S(L)),DABS(E(L)))
            SM = S(M)/SCALE
            SMM1 = S(M-1)/SCALE
            EMM1 = E(M-1)/SCALE
            SL = S(L)/SCALE
            EL = E(L)/SCALE
            B = ((SMM1 + SM)*(SMM1 - SM) + EMM1**2)/2.0D0
            C = (SM*EMM1)**2
            SHIFT = 0.0D0
            IF (B .EQ. 0.0D0 .AND. C .EQ. 0.0D0) GO TO 550
               SHIFT = DSQRT(B**2+C)
               IF (B .LT. 0.0D0) SHIFT = -SHIFT
               SHIFT = C/(B + SHIFT)
  550       CONTINUE
C
C	      I changed this line from - shift to + shift
C	      This bug was communicated by Ake Bjork
C	      Mike Meyer  jan 9 1984
C           F = (SL + SM)*(SL - SM) - SHIFT
C
            F = (SL + SM)*(SL - SM) + SHIFT
            G = SL*EL
C
C           CHASE ZEROS.
C
            MM1 = M - 1
            DO 560 K = L, MM1
               CALL DROTG(F,G,CS,SN)
               IF (K .NE. L) E(K-1) = F
               F = CS*S(K) + SN*E(K)
               E(K) = CS*E(K) - SN*S(K)
               G = SN*S(K+1)
               S(K+1) = CS*S(K+1)
               IF (WANTV) CALL DROT(P,V(1,K),1,V(1,K+1),1,CS,SN)
               CALL DROTG(F,G,CS,SN)
               S(K) = F
               F = CS*E(K) + SN*S(K+1)
               S(K+1) = -SN*E(K) + CS*S(K+1)
               G = SN*E(K+1)
               E(K+1) = CS*E(K+1)
               IF (WANTU .AND. K .LT. N)
     *            CALL DROT(N,U(1,K),1,U(1,K+1),1,CS,SN)
  560       CONTINUE
            E(M-1) = F
            ITER = ITER + 1
         GO TO 610
C
C        CONVERGENCE.
C
  570    CONTINUE
C
C           MAKE THE SINGULAR VALUE  POSITIVE.
C
            IF (S(L) .GE. 0.0D0) GO TO 580
               S(L) = -S(L)
               IF (WANTV) CALL DSCAL(P,-1.0D0,V(1,L),1)
  580       CONTINUE
C
C           ORDER THE SINGULAR VALUE.
C
  590       IF (L .EQ. MM) GO TO 600
C           ...EXIT
               IF (S(L) .GE. S(L+1)) GO TO 600
               T = S(L)
               S(L) = S(L+1)
               S(L+1) = T
               IF (WANTV .AND. L .LT. P)
     *            CALL DSWAP(P,V(1,L),1,V(1,L+1),1)
               IF (WANTU .AND. L .LT. N)
     *            CALL DSWAP(N,U(1,L),1,U(1,L+1),1)
               L = L + 1
            GO TO 590
  600       CONTINUE
            ITER = 0
            M = M - 1
  610    CONTINUE
      GO TO 360
  620 CONTINUE
      RETURN
      END

c----------------- SUN/PC version, April 13,1993------------
        program lenns
        implicit double precision(a-h,o-z)
        parameter(kmax=8,jdmax=10,nxmax=525,lmax=65)
        parameter(npmax=1+kmax*(jdmax+2),twopi=6.2831853)
        dimension xt(nxmax),xdat(nxmax),xlag(nxmax,jdmax),
     *      theta(npmax),svexp(lmax),qrexp(lmax),
     *      der(lmax,nxmax),tsav(20,npmax),rsav(20),xraw(nxmax)
        dimension h0(npmax,npmax)
        character*35 fname,outname
        common /size/ k,jd,nx,m,jforce
        common /xdata/ xt,xlag
        external objfun

c----------- Initialize random number generator
	write(*,*) 'enter seed for random numbers'
	write(*,*) 'integer between 1 and 150000'
	read(*,*) iseed
        
        rn=uran(-abs(mod(iseed,15000)))

c----------- Set initial Jacobian to identity matrix
	call setidmat(h0,npmax)
 
c----------- Read in parameters and minimization routine options
        open(11,file='lenns.par',status='old')
        read(11,10) fname
        read(11,10) outname
10      format(a35)
        read(11,*) nx,jt1,ltr,ifreq,jd1,jd2,k1,k2,kcrit,l1,l2,
     *             jtpsav,alf,jforce,jper,cgcv,scale,ftol1,ftol2,
     *             itmax1,itmax2,maxstep1,maxstep2,ibrent,fltol
        close(11)
	iprint=itmax1+itmax2

c----------- Check if jt1 is OK, and fix if necessary
	if (jtpsav.lt.0) then
	    jt1min=jd2*l2
	else
            jt1min=(jd2-1)*l2+jtpsav
	endif
	if (jt1.lt.jt1min) jt1=jt1min

c------------ read data series into xdat; set nx=total series length
       call getx(fname,xdat,nxmax,nx,ifreq,ltr)
	
c---------- Set up the output file
	call makeout(fname,outname,nx,jt1,ltr,ifreq,k1,k2,cgcv,
     *          kcrit,jtpsav,alf,scale,jforce,jper,ftol1,ftol2,
     *          itmax1,itmax2,maxstep1,maxstep2,ibrent,fltol)

c------------ Standardize values to predict: SD=1, mean=0 if alf=0
       call sdev(xdat,jt1+1,nx,sd,xbar)
       if (alf.eq.0.) then
         do 150 j=1,nx
           xdat(j)=xdat(j)-xbar
150      continue
       endif
       call dscal(nx,1./sd,xdat,1)

c------------------ START MAIN LOOP on time-delay and #lags
       do 1010 ldelay=l1,l2
       do 1005 jd=jd1,jd2

	jtp=jtpsav
	if (jtpsav.le.0) jtp=ldelay

        call recontp(xraw,xdat,xlag,nxmax,jdmax,nx,ldelay,jd,jt1,m,jtp)
c --------------- m is the # of state vectors (# rows in xlag)
	do 200 j=1,m
	    xt(j)=xraw(j)-alf*xlag(j,1)	    	
200	continue

c----------------- Add sin & cos terms if fitting forced model 
	if (jforce.gt.0) then
	    xper=float(jper)
	    do 210 j=1,m
		ajper=float(mod(j,jper))/xper
		xlag(j,jd+1)=cos(twopi*ajper)
		xlag(j,jd+2)=sin(twopi*ajper)
210	    continue
	endif
		
c---------------- Initialize markers for best # units 'so far'
        kbic=k1
        bicopt=10000.
	kgcv=k1
	gcvopt=10000.
	mbic=0
	mgcv=0
c------------------ START LOOP on # units
        do 1004 k=k1,k2

c ---------------- decide if it's time to quit increasing # units
          if (k.gt.(2+kbic)) mbic=mbic+1
	  if (k.gt.(2+kgcv)) mgcv=mgcv+1
	  if (kcrit.eq.0) kquit=mbic
	  if (kcrit.eq.1) kquit=mgcv
	  if (kcrit.eq.2) kquit=mbic*mgcv
	  if (kquit.gt.0) goto 1004
          npar=1+k*(jd+2+2*jforce)
          if (2*npar.gt.m) goto 1004
          if (npar.gt.npmax) goto 1004

          do 15 i=1,20
              rsav(i)=10000.
15        continue

c------------------ START LOOP on repeated fits
           do 99 irep=1,251

c----------------- initialize parameter choices
            eps=scale*10**( .01*(dfloat(irep)-126.) )
            call tinit(theta,npar,eps,100)

c------------------ do a high-tolerance fit
	    ibrent1=0	
            call bfgsfm(objfun,npar,npmax,theta,h0,ftol1,fltol,
     *              itmax1,maxstep1,fnew,iter,iprint,inform,ibrent1)

c            call npsol(npar,nclin,ncnln,nrowa,nrowj,nrowr,a,bl,bu,
c     *              confun,objfun,inform,iter,istate,c,cjac,clamda,
c     *              fnew,g,r,theta,iw,leniw,w,lenw)


            xm=float(m)
            bic=1.419+dlog(fnew)+0.5*float(npar)*dlog(xm)/xm
            imod=mod(irep-1,5)
            if(imod.eq.0) then 
                open (13,file='lenns.tmp',status='unknown',
     *                access='append')
                write(13,97) ldelay,jd,k,eps,fnew,bic,iter,inform
                write(*,97) ldelay,jd,k,eps,fnew,bic,iter,inform
                close(13)   
            endif
            imax=idamax(20,rsav,1)
            rmax=rsav(imax)
            if (fnew.lt.rmax) then
                rsav(imax)=fnew
                do 85 jpar=1,npar
                    tsav(imax,jpar)=theta(jpar)
85              continue
            endif
99       continue
c---------------------- END LOOP on repeated fits
                
         do 999 i=1,20
            do 997 jpar=1,npar
                    theta(jpar)=tsav(i,jpar)
997         continue

            call bfgsfm(objfun,npar,npmax,theta,h0,ftol2,fltol,
     *               itmax2,maxstep2,fnew,iter,iprint,inform,ibrent)

c            call npsol(npar,nclin,ncnln,nrowa,nrowj,nrowr,a,bl,bu,
c     *              confun,objfun,inform,iter,istate,c,cjac,clamda,
c     *              fnew,g,r,theta,iw,leniw,w,lenw)
                xm=float(m)
                bic=1.419+dlog(fnew)+0.5*float(npar)*dlog(xm)/xm
		gcv=(fnew/(1.-(cgcv*float(npar)/xm)))**2
                if (bic.lt.bicopt) then
                    kbic=k
                    bicopt=bic
                endif
		if (gcv.lt.gcvopt) then
		    kgcv=k
		    gcvopt=gcv
		endif

c------------------ Compute estimated LE if #lags > 0
		if (jd.gt.0) then
                    call dnetdx(npar,theta,der,ldelay,jtp,alf)
                    nlgs=jtp+(jd-1)*ldelay
                    call liapqr(nlgs,lmax,der,m,svexp,qrexp)
                    ebar=0.
                    ebarqr=0.
                    leq=igcdiv(ldelay,jtp)
                    do 686 jl=1,leq
                        ebar=ebar+svexp(jl)
                        ebarqr=ebarqr+qrexp(jl)
686                 continue
                    ebar=ebar/dfloat(leq)
                    ebarqr=ebarqr/dfloat(leq)
		else
		    ebar=-99.999
		    ebarqr=-77.777
		endif
                open(12,file=outname,status='old',access='append')
                write(12,98) ldelay,jd,k,fnew,bic,gcv,npar,iter,
     *                       inform,ebar,ebarqr
		close(12)
97          format(1x,3i3,2x,f7.3,2(2x,f9.6),2x,i5,i3)
98          format(1x,3i3,2x,f9.6,2(2x,f7.4),i3,i7,i3,2(2x,f7.3))

999         continue
           
1004    continue
c---------------------- END LOOP on #units
1005   continue
1010   continue
c---------------------- END MAIN LOOP on time delay and  #lags
       open(12,file=outname,status='old',access='append')
       write(12,*) '@ LENNS finished @'
       close(12)
       stop
       end

        subroutine dnetdx(npar,theta,der,ldelay,jtp,alf)
c
c       Input:
c           npar  = # of variables   (integer)
c           theta = Parameter values (vector of length nvar)
c           ldelay= time delay in attractor reconstruction
c           jtp   = prediction time
c           alf   = linear coefficient in most recent x(t) value
c        On output:
c        Der(i,j) contains the derivative of f(x_1,x_2,... ;theta)
c        with respect to x_i, evaluated at X=x( x(t-1), x(t-2),... ;theta)
c
        implicit double precision(a-h,o-z)
        parameter(kmax=8,jdmax=10,nxmax=525,lmax=65)
        parameter(npmax=1+kmax*(jdmax+2))
	parameter(zero=0.d0,one=1.d0,hf=0.5d0,two=2.d0)
        common /size/ k,jd,nx,m,jforce
        common /xdata/ xt,xlag
        dimension gama(kmax,jdmax),der(lmax,nxmax),h(jdmax),
     *   xt(nxmax),xlag(nxmax,jdmax),theta(npar),w(kmax,jdmax)
        do 15 i=1,lmax
            do 10 j=1,nxmax
                der(i,j)=zero
10          continue
15      continue
        m0=k+1
        j0=2*k+1
	jdf=jd+2*jforce
        do 30 iunit=1,k
            loc0=j0+(iunit-1)*jdf
            do 20 lag=1,jdf
                gama(iunit,lag)=theta(loc0+lag)
c               ---------- theta(1+iunit)=beta_i ---------
                w(iunit,lag)=theta(1+iunit)*gama(iunit,lag)
20          continue
30      continue
        do 100 it=1,m
            do 45 iunit=1,k
c               ----------  theta(m0+iunit)=mu_i --------
                uin=theta(m0+iunit)
                do 40 lag=1,jdf
                    uin=uin+gama(iunit,lag)*xlag(it,lag)
40              continue
                auin=abs(uin)
                dij=(two+auin +hf*(auin**2))
                h(iunit)=two*(one+auin)/(dij**2)
45          continue
            do 60 j=1,jdf
                djt=0.
                do 55 iunit=1,k
                    djt=djt+w(iunit,j)*h(iunit)
55              continue
                der(jtp+(j-1)*ldelay,it)=djt
60          continue
            der(jtp,it)=alf+der(jtp,it)
100     continue
        return
        end
  

       subroutine tinit(theta,npar,eps,nreps)
       implicit double precision(a-h,o-z)
       parameter(kmax=8,jdmax=10,nxmax=525,lmax=65)
       parameter(npmax=1+kmax*(jdmax+2))
       dimension theta(npmax),ti(npmax),g(npmax)
       twoeps=2.*eps
       fmin=10000.
       do 30 i=1,nreps
           do 10 j=1,npar
               ti(j)=twoeps*(uran(1)-0.5)
10         continue
           call objfun(0,npar,ti,fi,g,1)
           if(fi.lt.fmin) then
               call dcopy(npar,ti,1,theta,1)
               fmin=fi
           endif
30     continue
       return
       end

        subroutine setidmat(h,n)
	implicit real*8(a-h,o-z)
	dimension h(n,n)
	do 5 i=1,n
            do 3 j=1,n
               h(i,j)=0.
3           continue
            h(i,i)=1.
5       continue
	return
	end

	subroutine makeout(fname,outname,nx,jt1,ltr,ifreq,k1,k2,cgcv,
     *          kcrit,jtpsav,alf,scale,jforce,jper,ftol1,ftol2,
     *          itmax1,itmax2,maxstep1,maxstep2,ibrent,fltol)
	implicit double precision(a-h,o-z)
	character*35 fname,outname
        open(12,file=outname,status='unknown')
        write(12,100) fname
100     format(1x,'@ ',a35,'Output from LENNS.FOR')
        write(12,*) 'Dependent variable data scaled to Std Dev ==1'
	write(12,*) 'Parameter values:'
        write(12,110) nx,jt1,ltr,ifreq
110     format(i4,2x,3i3,9x,'<-- nx,jt1,ltr,ifreq')
        write(12,112) k1,k2,kcrit,cgcv
112	format(3(i3,2x),f6.3,3x,'<-- kmin,kmax,kcrit,cgcv')
	write(12,114) jtpsav,alf,scale
114	format(i3,2(2x,f5.2),7x,'<-- T_p,alfa,scale')
	write(12,115) jforce, jper
115	format(i3,2x,i5,14x,'<-- jforce, jper')
	write(12,116) ftol1,ftol2
116     format(e10.3,2x,e10.3,2x,'<-- ftol1,ftol2')
	write(12,118) itmax1,itmax2,maxstep1,maxstep2
118     format(1x,4(i5,2x),'<-- itmax1,itmax2,maxstep1,maxstep2')
	if (ibrent.gt.0) write(12,*) 'Polished with Brent,fltol= ',fltol
        write(12,*) 'output l,d,k,RMS err,BIC,GCV,#params,iters,
     *info,LE1(SV),LE1(QR) @'
        close(12)
	return
	end

        program cvmbed
        implicit double precision(a-h,o-z)
        parameter(jdmax=10,nxmax=1000)
        dimension xt(nxmax),xdat(nxmax),xlag(nxmax,jdmax),hvals(20)
        character*30 fname,outname
        common /xdata/ xt,xlag,cgcv,jd,nx,m,ipr,jw
	external rms

c----------- Read in parameters
        open(11,file='cvmbed.par',status='old')
        read(11,10) fname
        read(11,10) outname
10      format(a30)
        read(11,*) nx,jt1,ltr,ifreq,jd1,jd2,l1,l2,
     *       jtp1,jtp2,cgcv,ipr,jw
        close(11)
        csav=cgcv
        if (jw.lt.0) jw=0

c------------ read in data series; set nx=total series length
       call getx(fname,xdat,nxmax,nx,ifreq,ltr)

c---------- Set up the output files
        open(12,file=outname,status='unknown')
        write(12,110) fname,ltr
110     format(1x,'@ ',a30,'Output from CVEMBED.FOR',3x,'ltr=',i2)
        write(12,*) 'Data or transformed data scaled to Std Dev ==1'
        write(12,120) nx,jt1
120     format(1x,'max n= ',i6,' data pts, window length= ',i5)
        write(12,125) ifreq,cgcv,jw
125     format(1x, 'ifreq= ',i4, '  Cgcv= ',f5.2,' W= ',i4)
        write(12,*) 'output tp, l, d, CV_opt, h_opt, RMS_opt, r^2_opt @'
        close(12)

c------------------- Scale so SD of values to predict == 1
       sd=sdev(xdat,jt1+1,nx)
       call dscal(nx,1./sd,xdat,1)
       xbar=0.
       do 140 j=1,nx
         xbar=xbar+xdat(j)
140    continue
       xbar=xbar/dfloat(nx)
       do 150 j=1,nx
         xdat(j)=xdat(j)-xbar
150    continue

c------------------ START MAIN LOOP on prediction time, time-delay, #lags
       do 520 jtp=jtp1,jtp2
       do 510 ldelay=l1,l2
          do 500 jd=jd1,jd2

          maxback=jtp+(jd-1)*ldelay
          if(jt1.lt.maxback) goto 500

          call recontp(xt,xdat,xlag,nxmax,jdmax,nx,ldelay,jd,jt1,
     *        m,jtp)

c
c try to bracket a minimum of CV(h)
c
	  cvmin=100.
	  imax=15
	  do 400 i=1,imax
		hi=10.**( -4.0+ 0.5*dfloat(i-1))
		hvals(i)=hi
		cvi=rms(hi)
		if (cvi.lt.cvmin) then
			cvmin=cvi
			imin=i
		endif
400	  continue

c
c if bracketing failed, use endpoint as optimal bandwidth
c
	  if (imin.eq.1) then
		hcv=hvals(1)
		cvfn=cvmin	
	  elseif (imin.eq.imax) then
		hcv=hvals(imax)
		cvfn=cvmin
	  else
c
c if bracketing succeeded, find the minimum
c
	  	tol=.00001
		ax=hvals(imin-1)
		bx=hvals(imin)
		cx=hvals(imin+1)
	   	cvfn=ffmin(ax,bx,cx,rms,tol,hcv)
	  endif
c
c save CV(h_opt)
c
          cgcv=1.
          rmscv=rms(hcv)
	  r2=1.d0-rmscv**2
          cgcv=csav
	  open(12,file=outname,status='old',access='append') 
          write(12,210) jtp,ldelay,jd,cvfn,hcv,rmscv,r2
	  close(12)
210       format(1x,3i3,4(2x,f9.4))

500    continue
510    continue
520    continue
c---------------------- END MAIN LOOP
       close(12)
       stop
       end

c------------------------------------------------------------------------
c        Leave-one-out kernel regression estimates
c------------------------------------------------------------------------
      subroutine kregfhat(h,n,m,xk,y,npts,nvar,f,params,jw)

c   Computes leave-one-out kernel regression estimates at each data point,
c   for use in cross-validation.
c
c   Kernel used is a rational approximation to multivariate normal, based on
c   exp(-(x^2))=1/(1 + 0.5*x^2+ 0.3*x^6); here x is the Euclidean distance
c   between data points
c
c   Inputs:
c       h               bandwidth
c       xk(n,m)         independent variables data (column=variable)
c       y(n)            dependent variable data
c       nvar            number of indep variables
c       npts            number of data points
c   Outputs:
c       f(n)            predicted values by leave-one-out


      implicit double precision(a-h,o-z)
      parameter(zero=0.0,one=1.0)
      dimension xk(n,m),y(n),f(n)

      rh2= one/(h*h)
c----------- Loop on j is to predict at jth data point
      do 20 J=1,npts
        params=0.0
        tempd= 0.0
        tempn= 0.0

        do 10 I= 1,npts
          if (abs(i-j).le.jw) goto 10

c-------   loop over components of the vectors 
          dist=0.0
          do 5 jj=1,nvar
              dist= dist + (xk(j,jj)-xk(i,jj))**2
5         continue

c------     accumulate contribution from each data point
          x2=dist*rh2
          tempw= one/(one+ x2+ 0.5*x2**2 + 0.3*x2**3)
          tempn= tempn + tempw*y(i)
          tempd= tempd + tempw
10      continue

c------    normalize estimate
        f(j)= tempn/tempd

c------    accumulate contribution to effective # of parameters
        params=params+ (one/(one+tempd))

20    continue

      return    
      END    

c-------------------------------------------------------------------------
c                 Cross-validation function
c-------------------------------------------------------------------------
      function rms(h)
      implicit double precision(a-h,o-z)
      parameter(zero=0.0,one=1.0,nxmax=1000,jdmax=10)
      dimension xlag(nxmax,jdmax),xt(nxmax),fhat(nxmax)
      common /xdata/ xt,xlag,cgcv,jd,nx,m,ipr,jw
c
c  Compute the leave-out-2W+1 kernel estimate at each point
c

      call kregfhat(h,nxmax,jdmax,xlag,xt,m,jd,fhat,params,jw)
c
c   subroutine kregfhat(h,n,m,xk,y,npts,nvar,f,params,jw)
c       h               bandwidth
c       xk(n,m)         independent variables data (column=variable)
c       y(n)            dependent variable data
c       npts            number of data points
c       nvar            number of indep variables
c       jw              W, for leave-out-2W+1 estimate
c   Outputs:
c       f(n)            predicted values by leave-out-2W+1
c       params          effective number of parameters, tr(A(h)) 

      sse=0.
      do 2 j=1,m
        sse=sse+(fhat(j)-xt(j))**2
2     continue
      rms=sqrt(sse/dfloat(m-1))
      if (ipr.gt.0) write(*,*) rms,h,params
c
c       Compute modified cross-validation function V_c
c
      pmax=dfloat(m)/cgcv
      if (params.ge.pmax) then
         rms=10.
      else
         xm=dfloat(m)
         rms=rms*(xm-params)/(xm-cgcv*params)
      endif
      return
      end

C------ CONFUN & MAKEOPT are for use by NPSOL, otherwise not used 
        SUBROUTINE CONFUN(MODE,NCNLN,N,NROWJ,NEEDC,X,C,CJAC,NSTATE)
        IMPLICIT double precision (A-H,O-Z)
        INTEGER*4 MODE,NCNLN,N,NROWJ
        INTEGER*4 NEEDC(*)
        REAL*8 X(N),C(*),CJAC(NROWJ,*)
        SAVE
        RETURN
        END

        subroutine makeopt(bigbnd,itmax1,itmax2,ftol1,ftol2,msglvl,
     *                     mverify)
        implicit double precision(a-h,o-z)
      OPEN(7,FILE='options1.dat',status='unknown')
      rewind(7)
      WRITE(7,7000)
      write(7,7010)
      WRITE(7,7001) BIGBND
      WRITE(7,7002) ITMAX1
      WRITE(7,7004) FTOL1
      WRITE(7,7005) MSGLVL
      WRITE(7,7006) MVERIFY
      WRITE(7,7900)
      close(7)


      OPEN(7,FILE='options2.dat',status='unknown')
      rewind(7)
      WRITE(7,7000)
      write(7,7010)
      WRITE(7,7001) BIGBND
      WRITE(7,7002) ITMAX2
      WRITE(7,7004) FTOL2
      WRITE(7,7005) MSGLVL
      WRITE(7,7006) MVERIFY
      WRITE(7,7900)
      close(7)

      ITMAX3=int(sqrt(dfloat(itmax1*itmax2)))
      OPEN(7,FILE='options3.dat',status='unknown')
      rewind(7)
      WRITE(7,7000)
      write(7,7010)
      WRITE(7,7001) BIGBND
      WRITE(7,7002) ITMAX3
      WRITE(7,7004) sqrt(FTOL1*FTOL2)
      WRITE(7,7005) MSGLVL
      WRITE(7,7006) MVERIFY
      WRITE(7,7900)
      close(7)

7000  FORMAT('BEGIN',74X,' ')
7010  format('   NOLIST                    ',48x,' ')
7001  FORMAT('   INFINITE BOUND            ',D15.3,35X,' ')
7002  FORMAT('   MAJOR ITERATION LIMIT     ',I15  ,35X,' ')
7004  FORMAT('   OPTIMALITY TOLERANCE      ',D15.3,35X,' ')
7005  FORMAT('   MAJOR PRINT LEVEL         ',I15  ,35X,' ')
7006  FORMAT('   VERIFY LEVEL              ',I15  ,35X,' ')
7008  FORMAT('   LINESEARCH TOLERANCE      ',D15.3,35X,' ')
7900  FORMAT('END  ',74X,' ')
      return
      end


        subroutine sdev(x,n1,n,sd,ave)
c
c    Purpose: calculates standard deviation of values n1,n2,....n
c             in array x of length n
c
        implicit double precision(a-h,o-z)
        dimension x(n)
        xn=float(n-n1+1)
        ave=0.
        do 10 i=n1,n
            ave=ave+x(i)
10      continue
        ave=ave/xn
        var=0.
        do 20 i=n1,n
            var=var+(x(i)-ave)**2
20      continue
        var=var/(xn-1.)
        sd=sqrt(var)
        return
        end

        integer*4 function igcdiv(i1,i2)
        implicit integer*4(i-n)
        igcd=0
        imin=min(i1,i2)
        do 10 i=1,imin
            ir1=mod(i1,i)
            ir2=mod(i2,i)
            if (ir1.eq.0.and.ir2.eq.0) igcd=i
10      continue
        igcdiv=igcd
        return
        end

       subroutine getx(fname,xdat,nxmax,nx,ifreq,ltr)
       implicit double precision(a-h,o-z)
       character*30 fname
       dimension xdat(nxmax)
       open(unit=11,file=fname,status='old')
       rewind(11)
       iskip=ifreq-1
       m=0
       do 50 i=1,nx
           read(11,*,end=60) xdat(i)
           m=m+1
           if (ifreq.gt.1) then
                do 40 j=1,iskip
                    read(11,*,end=60) xjunk
40              continue
           endif
           if (ltr.gt.0) xdat(i)=dlog(xdat(i))
50      continue
60     continue
       close(11)
       if (m.lt.nx) nx=m
       return
       end

        subroutine recontp(xt,xdat,xlag,nxmax,jdmax,nx,ldelay,
     *     jd,jt1,m,jtp)
        implicit double precision(a-h,o-z)
        dimension xt(nxmax),xdat(nxmax),xlag(nxmax,jdmax)
        m=0
        do 10 i=1,nx-jt1
           m=m+1
           ipred=i+jt1
           xt(i)=xdat(ipred)
	   if (jd.gt.0) then	
             do 5 j=1,jd
               iback=jtp+(j-1)*ldelay
               xlag(i,j)=xdat(ipred-iback)
5            continue
	   endif
10      continue
        return
        end


      double precision function uran(iseed)
      integer  iy
c    ==> the uran code was grabbed from netlib at ORNL.
c
c      urand is a uniform random number generator based  on  theory  and
c  suggestions  given  in  d.e. knuth (1969),  vol  2.   the integer  iy
c  should be initialized to an arbitrary integer prior to the first call
c  to urand.  the calling program should  not  alter the  value  of  iy
c  between  subsequent calls to urand. values of urand will be returned
c  in the interval (0,1).
c
c    ==> uran is modified for LENNS so that if iseed.le.0, the generator is
c        reseeded, otherwise it iterates from the current value of iy
c        (stored internally), so the calling program can use any
c        positive value of iseed after the generator has been seeded.
c
      integer  ia,ic,itwo,m2,m,mic
      double precision  halfm,uran,s
      double precision  datan,dsqrt
      data m2/0/,itwo/2/
      if(iseed.le.0) iy=abs(iseed)
      if (m2 .ne. 0) go to 20
c
c  if first entry, compute machine integer word length
c
      m = 1
   10 m2 = m
      m = itwo*m2
      if (m .gt. m2) go to 10
      halfm = m2
c
c  compute multiplier and increment for linear congruential method
c
      ia = 8*idint(halfm*datan(1.d0)/8.d0) + 5
      ic = 2*idint(halfm*(0.5d0-dsqrt(3.d0)/6.d0)) + 1
      mic = (m2 - ic) + m2
c
c  s is the scale factor for converting to floating point
c
      s = 0.5/halfm
c
c  compute next random number
c
   20 iy = iy*ia
c
c  the following statement is for computers which do not allow
c  integer overflow on addition
c
      if (iy .gt. mic) iy = (iy - m2) - m2
c
      iy = iy + ic
c
c  the following statement is for computers where the
c  word length for addition is greater than for multiplication
c
      if (iy/2 .gt. m2) iy = (iy - m2) - m2
c
c  the following statement is for computers where integer
c  overflow affects the sign bit
c
      if (iy .lt. 0) iy = (iy + m2) + m2
      uran = float(iy)*s
      return
      end

      subroutine liapqr(nlags,ldder,der,n,lexpsv,lexpqr)

c Purpose: create the Jacobian and update the product
c       of Jacobians with the current vector of partial 
c       derivatives; using this product the
c       Lyapunov exponents are estimated
c
c On Entry:
c   nlags                number rows in der, number of lags in model
c   der(nlags,n)         matrix of partial derivatives
c   ldder                leading dimension (#rows) of der in calling routine
c   
c On Exit:
c   lexpsv(nlags)          arrays of ordered estimated Lyapunov exponents, from
c   lexpqr(nlags)             SVD and QR decompositions, respectively
c Subprograms Called Directly:
c       Linpack - dsvdc,dqrdc
c Should be linked with Double-precision BLAS

      parameter(LMAX=65,LDW=6*LMAX)
      INTEGER nlags,info

      double precision jac(lmax,lmax),s(lmax,lmax),t(lmax,lmax),
     * v(lmax,lmax),u(lmax,lmax),e(LMAX),epsln,
     * der(ldder,n),lexpsv(nlags),cnorm,w(LMAX),norm,work(LDW),
     * lexpqr(nlags),qraux(LMAX),one,zero
      integer jpvt(LMAX)
	parameter(one=1.d0, zero=0.d0)

      epsln= 1.0d-15
      if (LMAX.lt.ldder) then
          write(*,*) ' Not enough storage in liapest'
          stop
      endif

c---------------- Initialize S=identity matrix
      do 110 i=1,nlags
        do 100 j=1,nlags
            s(i,j)=zero
100     continue
        s(i,i)=one
110   continue


c----------------- Initialize fixed elements of Jacobian matrix
      DO 130 I=1,NLAGS
          DO 120 J=1,NLAGS                                          
              jac(I,J)=zero                                      
              IF (I.EQ.(J+1)) THEN                               
                 jac(I,J)=one                                     
              ENDIF                                            
120            CONTINUE                                        
130        CONTINUE                                           
      CNORM=zero                                            

c--------------------- Loop over kk=1,2,.. n to compute T_n
      do 200 kk=1,n

c--------------------- Put derivatives at time kk into Jac
      DO 10 I=1,NLAGS                                              
          jac(1,I)=DER(I,kk)                                           
10    CONTINUE

c--------------------- Update T(kk-1) by multiplying by Jac(kk)
      DO 13 I=1,NLAGS
          DO 12 J=1,NLAGS                                     
              T(I,J)=zero                                    
              DO 11 K=1,NLAGS                               
                  T(I,J)=jac(I,K)*S(K,J)+T(I,J)              
11            CONTINUE
12        CONTINUE
13    CONTINUE


c------------------ Normalize to Max(abs(T_i,j)) == 1
      NORM=zero
      DO 15 I=1,NLAGS                                             
          DO 14 J=1,NLAGS                                        
              NORM=MAX(NORM,ABS(T(I,J)))                        
14            CONTINUE                                         
15        CONTINUE                                            

      DO 17 I=1,NLAGS                                                 
          DO 16 J=1,NLAGS                                            
              T(I,J)=T(I,J)/NORM
              S(I,J)=T(I,J)
16            CONTINUE                                             
17        CONTINUE                                                

c---------------- Update Cnorm=cumulative log of renormalizations
      CNORM=LOG(NORM)+CNORM                                     

200   continue

c------------- Estimate of LE's based on SV decomposition
c     SUBROUTINE DSVDC(X,LDX,N,P,S,E,U,LDU,V,LDV,WORK,JOB,INFO)
      call dsvdc(t,LMAX,nlags,nlags,W,E,U,LMAX,V,LMAX,         
     *           work,00,info)

      if( info.gt.0) then
           write(*,*) 'info from svddc', info
      endif

      do 210 k=1, nlags
        if( abs(w(k)).gt.epsln) then
           lexpsv(k)= (LOG(ABS(w(k)))+CNORM)/dfloat(n)
        else
           lexpsv(k)=(log(epsln) +cnorm)/dfloat(n)
       endif
210   continue

c---------- Estimate of LE's based on QR decomposition
c     SUBROUTINE DQRDC(X,LDX,N,P,QRAUX,JPVT,WORK,JOB)
      call dqrdc(S,LMAX,NLAGS,NLAGS,QRAUX,JPVT,WORK,0)

      do 220 k=1,nlags
        if(abs(S(k,k)).gt.epsln) then
           lexpqr(k)= (LOG(ABS(S(k,k)))+CNORM)/dfloat(n)
        else
           lexpqr(k)= (log(epsln)+cnorm)/dfloat(n)
        endif
220   continue

      if(nlags.gt.1) then

c    -- sort lexpqr in ascending order
	call sort(nlags,lexpqr)

c    -- reverse into descending order
        do 230 k=1,nlags
          w(k)=lexpqr(nlags+1-k)
230     continue
        do 240 k=1,nlags
          lexpqr(k)=w(k)
240     continue
      endif
      RETURN                                                          
      END


      subroutine sort(n,x)
      implicit real*8(a-h,o-z)
      dimension x(n)
      l=n/2+1
      ix=n
5     continue
        if(l.gt.1)then
          l=l-1
          xx=x(l)
        else
          xx=x(ix)
          x(ix)=x(1)
          ix=ix-1
          if(ix.eq.1)then
            x(1)=xx
            return
          endif
        endif
        i=l
        j=l+l
10      if(j.le.ix)then
          if(j.lt.ix)then
            if(x(j).lt.x(j+1))j=j+1
          endif
          if(xx.lt.x(j))then
            x(i)=x(j)
            i=j
            j=j+j
          else
            j=ix+1
          endif
        go to 10
        endif
        x(i)=xx
      go to 5
      end

        subroutine bfgsfm(fcn,nvar,np,p,h0,ftol,maxiter,
     *                  maxstep,fnew,iter,iprint,inform)

        implicit real*8(a-h,o-z)
        character*1 trans
        parameter(nvmax=100,eps=1.d-16,one=1.0,zero=0.0,trans='N')
        dimension p(np),pnew(nvmax),h0(np,np),g(nvmax),
     *            gnew(nvmax),h(nvmax,nvmax),xi(nvmax),work(nvmax),
     *            dx(nvmax),shy(nvmax),shys(nvmax,nvmax)
        external fcn
        sftol=sqrt(ftol)
        cftol=ftol**0.35d0
        ymin=-0.001
        inform=0
        jset=1

        call fcn(2,nvar,p,fp,g,0)
        do 10 i=1,nvar
            do 5 j=1,nvar
                h(i,j)=h0(i,j)
5           continue
10      continue

c---------------- set xi = -h*g
        call dgemv(trans,nvar,nvar,-1.d0,h,nvmax,g,1,zero,xi,1)

        nfail=0
        jhct=0
        do 99 iter=1,maxiter
12          call bhhhstp(fcn,nvar,p,fp,xi,g,maxstep,s,fnew,iters,info)

c---------------- check for failed step; reset hessian & search direction
            if (fnew.gt.fp) then
                if (jset.eq.1) then
                    inform=1
                    fnew=fp
                    goto 999
                endif
                nfail=nfail+1
                jset=1
                do 15 i=1,nvar
                    do 14 j=1,nvar
                        h(i,j)=h0(i,j)
14                  continue
15              continue

                call dgemv(trans,nvar,nvar,-1.d0,h,nvmax,g,1,zero,xi,1)
                goto 12
            else

c---------------- set pnew=p+s*xi and compute new gradient
            call dcopy(nvar,p,1,pnew,1)
            call daxpy(nvar,s,xi,1,pnew,1)
            call fcn(1,nvar,pnew,fjunk,gnew,0)

c------------------ print out results every iprint iteration
            itermod=mod(iter,iprint)
            if (itermod.eq.0) then
                imax=idamax(nvar,gnew,1)
                gnorm=ddot(nvar,gnew,1,gnew,1)
                write(*,21)iter,fnew,(fp-fnew)/abs(fp),gnorm,
     *                      nfail,jhct,jbr
21              format(1x,i8,2x,f12.8,2x,e13.6,2x,f12.8,2x,3i4)
                nfail=0
                jhct=0
		jbr=0
            endif

c----------------- Check if convergence criteria satisfied
            imax=idamax(nvar,gnew,1)
            gmax=abs(gnew(imax))
            if(gmax.lt.eps) then
                goto 999
            else
                if ( (fp-fnew).lt.ftol*(1.+fnew)) then
                    if(gmax.lt.cftol*(1.+abs(fnew))) then
                        imax=idamax(nvar,pnew,1)
                        pmax=abs(pnew(imax))
                        call dcopy(nvar,pnew,1,work,1)
                        call daxpy(nvar,-1.d0,p,1,work,1)
                        imax=idamax(nvar,work,1)
                        dpmax=abs(work(imax))
                        if (dpmax.lt.sftol*(1.+pmax)) then
                            goto 999
                        endif
                    endif
                endif
            endif

c--------------------- If not, prepare for the next iteration
c        set dx=pnew-p
            call dcopy(nvar,pnew,1,dx,1)
            call daxpy(nvar,-1.d0,p,1,dx,1)

c        set shy=dx-h*gnew+h*g
            call dcopy(nvar,dx,1,shy,1)
            call dgemv(trans,nvar,nvar,-1.d0,h,nvmax,gnew,1,1.d0,shy,1)
            call dgemv(trans,nvar,nvar,1.d0,h,nvmax,g,1,1.d0,shy,1)

c        set shys=(shy*dx')+(shy*dx')'
            do 30 i=1,nvar
                do 25 j=1,nvar
                    shys(i,j)=shy(i)*dx(j) + shy(j)*dx(i)
25              continue
30          continue

c        set yshy=gnew'*shy-g'*shy
            y1=ddot(nvar,gnew,1,shy,1)
            y2=ddot(nvar,g,1,shy,1)
            yshy=y1-y2

c        set ys=gnew'*dx-g'*dx
            y1=ddot(nvar,gnew,1,dx,1)
            y2=ddot(nvar,g,1,dx,1)
            ys=y1-y2

c       update h if ys>0, otherwise reset h
            if (ys.gt.0.) then
                jset=0
                call dger(nvar,nvar,-yshy/ys,dx,1,dx,1,shys,nvmax)
                do 40 i=1,nvar
                    do 35 j=1,nvar
                        h(i,j)=h(i,j)+shys(i,j)/ys
35                  continue
40              continue
            else
                jset=1
                do 50 i=1,nvar
                    do 45 j=1,nvar
                        h(i,j)=h0(i,j)
45                  continue
50              continue
                jhct=jhct+1
            endif

c       update f,g,p, and search direction
            call dcopy(nvar,gnew,1,g,1)
            call dcopy(nvar,pnew,1,p,1)
            fp=fnew
            call dgemv(trans,nvar,nvar,-1.d0,h,nvmax,g,1,0.d0,xi,1)

c------------------- If next step "points up", reset Hessian
            y1=ddot(nvar,xi,1,g,1)
            y2=ddot(nvar,xi,1,xi,1)
            if (y1.ge.ymin*y2) then
                jset=1
                do 60 i=1,nvar
                    do 55 j=1,nvar
                        h(i,j)=h0(i,j)
55                  continue
60              continue
                call dgemv(trans,nvar,nvar,-1.d0,h,nvmax,g,1,0.d0,xi,1)
                jhct=jhct+1
            endif

        endif

99      continue

999     return
        end

        subroutine bhhhstp(fcn,nvar,x0,f0,d,g,itermax,s,fs,
     *                      iters,info)
        implicit real*8(a-h,o-z)
        parameter(delta=0.25,pwr=0.618,one=1.0,nvmax=100)
        dimension x0(nvar),d(nvar),g(nvar),work(nvmax)

c--------------------- Initializations
        info=1
        iter=0
        iup=0
        idown=0
        factor=2.
        dg=ddot(nvar,d,1,g,1)
        downfact=dg*delta
        upfact=dg*(1.-delta)
        alam=1.0
        if (itermax.eq.0) itermax=25

        do 10 iter=1,itermax

c----------------- Set g= alam*d + x0, vof=fcn(g)
            call dcopy(nvar,x0,1,work,1)
            call daxpy(nvar,alam,d,1,work,1)
            call fcn(0,nvar,work,vof,g,1)

c------------------ vof above cone, hence reduce step size
            if ((vof-f0).gt.(downfact*alam)) then
                idown=1
                if (iup.eq.1) then
                    factor=factor**pwr
                    iup=0
                endif
                alam=alam/factor

c------------------ vof below cone, hence increase step size
            else if ((vof-f0).lt.(upfact*alam)) then
                iup=1
                if (idown.eq.1) then
                    factor=factor**pwr
                    idown=0
                endif
                alam=alam*factor

c------------------ vof within cone, hence stop iterations
            else
                info=0
                goto 20
            endif
10      continue

20      continue

c------------------- compute returned values
        iters=iter
        s=alam
        fs=vof
        return
        end
